//+------------------------------------------------------------------+
//|                                                makeIndicator.mq4 |
//|                                             Copyright  2016, E1 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, E1"
#property link      "http://www.hlaiman.com"
#property show_inputs

#define S_OK     0      // status ok!
#define TIM_ERR  0.1    // check bars time
#define HOUR_SEC 3600
#define SIG_MAX 1.0
#define SIG_MIN -1.0
#define SIG_NUL 0.0
#define S_PARAM "Indicator parameters "
#define S_INIT  "Neural initialization "
#define S_MAKE  "Neural net generation "

//#include <stderror.mqh>
//#include <stdlib.mqh>

#import  "mt4.dll"
//  int InitEx(string symbol, int period, string name, int count);
  int InitInd( string expert, int count);
  int PatternInd( string symbol, int period, string name, double& data[], int out, int in, int index ); 
  int SaveEx( string symbol, int period, int layers, int neurons, int epoch, int count );
  int DeinitEx( int count );
#import
 
extern int      SignalBarPoints = 10;
extern int      PatternBarsCount = 18;
extern int      NetLayersCount = 3;
extern int      NetNeuronsCount = 60;
extern int      NetEpochCount = 10000;
extern datetime StartTime = D'2014.01.24 00:00';
extern datetime EndTime   = D'2014.01.26 00:00';

static string   Name = "arrow",  PrefixUp = "arrowUp" ,  PrefixDn = "arrowDn";
static string   IndicatorName = "in_";
static int      SignalPips;
static double   makePattern[];
static bool     norm = true;//false;
//+------------------------------------------------------------------+
//| start function                                                   |
//+------------------------------------------------------------------+
int start()
{
  int  patup, patdn, errpat, bars = Bars - PatternBarsCount, res = -1;
  double pips;
  if (MarketInfo(Symbol(), MODE_DIGITS) == 5 || MarketInfo(Symbol(), MODE_DIGITS) == 3)
  SignalPips = SignalBarPoints * 10; else SignalPips = SignalBarPoints;
//  IndicatorDelta = Response / SIG_PER;
  ArrayResize(makePattern, PatternBarsCount + 1);
//  if(EndTime != 0) while(Time[i] > EndTime) i++;
  if(StartTime <= EndTime) {
//    if(InitEx(ExpertName + Symbol() + Period(), 1) == S_OK) {
    if(InitInd(IndicatorName + Symbol(), 1) == S_OK) {
      patup = 0; patdn = 0; errpat = 0;
      for (int i = bars; i > 0; i--) {
        if(StartTime != 0 && Time[i] < StartTime) continue;
        if(EndTime != 0 && Time[i] > EndTime) break;
//        if(MathAbs((Open[i] - Close[i]) / Point) < minpips) continue;
        if(FillPattern(Symbol(), Period(), Time[i]) != true) errpat++; else {
          if(errpat > 0) Print("Aborted on ", patup + patdn, " - ", errpat, " invalid patterns!");
          errpat = 0;
          pips = MathAbs((Open[i] - Close[i]) / Point);
          if (pips > SignalPips) {
            if (Open[i] > Close[i]) makePattern[0] = SIG_MIN; else makePattern[0] = SIG_MAX;
          } else {
            if(Open[i] > Close[i]) makePattern[0] =  - (pips / SignalPips);
            else if(Open[i] < Close[i]) makePattern[0] = (pips / SignalPips);
            else makePattern[0] = SIG_NUL;
          }
          if (Open[i] > Close[i]) {
            patdn++;
            Name = PrefixDn + IntegerToString(patdn); 
          } else {
            patup++;
            Name = PrefixUp + IntegerToString(patup); 
          }
          PatternInd(Symbol(), Period(), Name, makePattern, 1, ArraySize(makePattern) - 1, 0);
        }
      }
      if(patup > 0 || patdn > 0) {
//        if(makeSave(Symbol(), Period(), 1) >= 1)
        if(SaveEx(Symbol(), Period(), NetLayersCount, NetNeuronsCount, NetEpochCount, 1) >= 1) {
          Print(S_MAKE, "Success! On ", patup, " Up patterns and ", patdn, " Dn patterns");
//          Retrain = false;
          res = 0;
        } else Print(S_MAKE, "Error! On ", patup + patdn, " patterns");
      } else Print("make Neural net Error! No patterns...");	
      DeinitEx(1);
    } else Print(S_INIT, " Error!");
  } else Print(S_PARAM, " Error!"); 
  return(res);
}
//+------------------------------------------------------------------+
bool FillPattern(string symbol, int period, datetime tim = 0)
{
  if(ArraySize(makePattern) < PatternBarsCount + 1 || period < 0) return(false);
  double hi, lo, op, cl;
  int i, ii = 1, ind = 0, iend;
  if(tim > 0) while(tim < iTime(symbol, period, ind)) ind++;
  iend = ind + ArraySize(makePattern) - 1; 
  for(i = ind; i <= iend; i++) // Validate bars time
  if(period < 60) // if < H1
  if(MathAbs(iTime(symbol, period, i) - iTime(symbol, period, i + 1) - period * 60) > (period * 60 * TIM_ERR))
  return(false);
  while(ind <= iend) {
    hi = iHigh(symbol, period, ind);
    lo = iLow(symbol, period, ind);
    op = iOpen(symbol, period, ind);
    cl = iClose(symbol, period, ind);
    if(hi <= lo) makePattern[ii] = 0.0; else    //return(false); else
    makePattern[ii] = (((lo - op) - (hi - cl)) / (hi - lo));
    ind++;
    ii++;
  }
  if(norm == true) return((Normalize())); else
  return(true);
}
//+------------------------------------------------------------------+
bool Normalize()
{
  int i;
  double ma, mi, he;
  ma = makePattern[1];
  mi = makePattern[1];
  for(i = 2; i < ArraySize(makePattern); i++) {
    if (ma < makePattern[i]) ma = makePattern[i];
    if (mi > makePattern[i]) mi = makePattern[i];
  }
  if(ma <= mi) return(false);
  he = 2 / (ma - mi);
  for(i = 1; i < ArraySize(makePattern); i++)
  makePattern[i] = ((makePattern[i] - mi - 1) * he); 
  return(true); 
}
//+------------------------------------------------------------------+